/*
#############################################################
#                                                           #
#   G Language Example : Second degree equation solving     #
#                                                           #
#   Author: Quentin Dem                                    #
#           qdeme@yahoo.fr                                  #
#                                                           #
#############################################################
*/

entry {
    echo("Solving a second degree equation :)",1);
    echo("P(x) = ax^2 + bx + c",1);

    echo("a = ",0); int a; input(a,int);
    echo("b = ",0); int b; input(b,int);
    echo("c = ",0); int c; input(c,int);

    echo("P(x) = " & a & "x^2 + " & b & "x + " & c,1);

    int delta = b*b - 4*a*c;
    echo("",1);

    echo("Delta = " & delta,1); echo("",1);

    float delta_float = delta;
    float b_float = b;
    float a_float = a;

    if (delta > 0) {
        echo("Delta > 0 => 2 solutions x1 and x2",1);

        float x1 = (-b_float - sqrt(delta_float)) / (2*a_float);
        echo("--> x1 = " & x1,1);
        float x2 = (-b_float + sqrt(delta_float)) / (2*a_float);
        echo("--> x2 = " & x2,1);
    }
    elseif (delta < 0) {
        echo("Delta < 0 => no solution in R",1);
    }
    else {
        echo("Delta = 0 => one double solution x1",1);

        float x1 = -b_float / (2*a);
        echo("--> x1 = " & x1,1);
    }
}
