/*
#########################################################
#                                                       #
#           Example of IRC Bot in G Language            #
#   - Author:         Quentin DEME                      #
#   - Email address : qdeme@yahoo.fr                    #
#   - Made:           2008/02/11                        #
#                                                       #
#########################################################

The bot will connect to the IRC server on host:port.
Once he's joined the channel 'botchan', 2 commands are allowed (it's a minimal bot, I agree):
  - !info
  - !quit

*/


// Nickname of the bot
string botnick = "G-BOT";
// IRC Server IP Address
string host = "91.121.59.5";
// IRC Server Port Number
int port = 6667;
// Name of the channel the BOT will join
string botchan = "#G-FACTION";
// Message the bot will say when joining the channel
string entrymsg = "Hello everybody ! ^^ I'm " $+ botnick $+ " and I was made in G Language ! :p";

char r = 10; // '\r'
char n = 13; // '\n'
char g = 34; // '"'

proc sw(string msg) { SockWrite("server",msg $+ r); }

proc OnConnect() {
	// Commands to perform when connecting to the server
	sw("JOIN " $+ botchan);
}

entry {
	int verbose = 0;
	if (entryNbParam > 1) {
		if (entryParam[1] == "-v") {
			verbose = 1;
		}
		else {
			echo("Unknown option '" & entryParam[1] & "'",1);
			echo("Option :",1);
			echo("         -v (Verbose : displays what's received from the server)",1);
			exit(0);
		}
	}
	echo("Connecting to " & host & ":" & port & "...",1);
	int err = SockOpen("server",host,port);
	if (err) {
		echo("Couldn't connect to server",1);
		exit(0);
	}
	int connected = 1;
	echo("Connected",1);
	sw("NICK " $+ botnick);
	sw("USER h " $+ g $+ g $+ " " $+ g $+ host $+ g $+ " :" $+ botnick);
	string rc = "a";
	while (connected && (rc != "")) {
		rc = SockRead("server");
		string recv = "";
		char a;
		int b;
		int nb = NumTok(rc,n);
		for (int i = 1; i <= nb; i=i+1) {
			recv = GetTok(GetTok(rc,r,i,0),n,1,0);
			if (verbose) { echo(recv,1); }
			if (GetTok(recv,' ',1,0) == "PING") {
				sw("PONG " $+ GetTok(recv,' ',2,0));
			}
			elseif (GetTok(GetTok(recv,':',2,0),'!',1,0) == botnick) {
				if (GetTok(GetTok(recv,' ',3,0),':',2,0) == botchan) {
					echo(botnick & " has joined " & botchan,1);
					sw("PRIVMSG " $+ botchan $+ " :" $+ entrymsg $+ n);
				}
			}
			elseif (GetTok(recv,' ',2,0) == "PRIVMSG") {
				string chan = GetTok(recv,' ',3,0);
				string msg = GetTok(GetTok(recv,' ',4,1),':',2,1);
				string nick = GetTok(GetTok(recv,':',2,1),'!',1,0);
				msg = GetTok(msg,n,1,0);
				if (GetTok(msg,' ',1,0) == "!info") {
					echo("Received !info command",1);
					sw("PRIVMSG " $+ chan $+ " :You are " $+ g $+ nick $+ g $+ ", and you said " $+ g $+ msg $+ g $+ " on " $+ g $+ chan $+ g);
				}
				elseif (GetTok(msg,' ',1,0) == "!quit") {
					echo("Received !quit command",1);
					sw("QUIT");
					connected = 0;
				}
				elseif (GetTok(msg,' ',1,0) == "PING") {
					sw("PONG " $+ GetTok(msg,' ',2,0));
				}
			}
			elseif (GetTok(recv,' ',2,0) == "001") {
				OnConnect();
			}
		}
	}
	echo("Disconnected",1);
}
