/*
#############################################################
#                                                           #
#   G Language Example : A program that does a small part   #
#                        of what's possible to do in        #
#                        G language. Shows the use of       #
#                        menus.                             #
#                                                           #
#   Author: Quentin Dem                                    #
#           qdeme@yahoo.fr                                  #
#                                                           #
#############################################################
*/

proc menu() {
    echo("",1);
    echo("------      G Language demonstration      ------",1);
    echo("------ Choose one of the options below... ------",1);
    echo("",1);
    echo("  - 0 Quit",1);
    echo("  - 1 Fill an array",1);
    echo("  - 2 Launch another G language script",1);
    echo("  - 3 Send a command to the system",1);
    echo("  - 4 Launch file manipulation menu",1);
    echo("-------------------------------------------------",1);
    echo("",1);
}

proc menuFileManip() {
    echo("",1);
    echo("------         File Manipulation         ------",1);
    echo("------ Choose one of the options below... ------",1);
    echo("",1);
    echo("  - 0 Quit File Manipulation menu",1);
    echo("  - 1 Create an empty file",1);
    echo("  - 2 Write in a file",1);
    echo("  - 3 Get the number of lines of a file",1);
    echo("  - 4 Read a file",1);
    echo("-------------------------------------------------",1);
    echo("",1);
}

proc createFile() {
    echo("Name of file to create : ",0);
    string fname;
    input(fname,string);
    FileCreate(fname);
    echo("File created, opening...",1);
    System(fname);
}

proc writeFile() {
    echo("File name : ",0);
    string fname;
    input(fname,string);
    echo("Text to write in " & fname & " : ",0);
    string text;
    input(text,string);
    echo("Line : ",0);
    int line;
    input(line,int);
    FileWriteLine(fname,text,line);
    echo("Text written in " & fname & " at line " & line,1);
}

proc getNbOfLines() {
    echo("File name : ",0);
    string fname;
    input(fname,string);
    int nb = FileLines(fname);
    echo("Number of lines in " & fname & " : " & nb,1);
}

proc readFile() {
    echo("File name : ",0);
    string fname;
    input(fname,string);
    int nblignes = FileLines(fname);
    for (int i = 1; i <= nblignes; i=i+1) {
        echo("Line " & i & " : " & FileReadLine(fname,i),1);
    }
    echo("End of file",1);
}

proc fileManip() {
    int ok = 1;
    int choice;
    while (ok) {
        menuFileManip();
        echo("> ",0);
        input(choice,int);
        echo("",1);

        switch (choice) {
            case (0) {
                ok = 0;
            }
            case (1) {
                createFile();
            }
            case (2) {
                writeFile();
            }
            case (3) {
                getNbOfLines();
            }
            case (4) {
                readFile();
            }
            default {
                echo("Invalid choice",1);
            }
        }
    }
}

proc LaunchScript() {
    echo(".g file to launch : ",0);
    string script;
    input(script,string);
    System(script);
}


proc SendCommand() {
    echo("Command > ",0);
    string cmd;
    input(cmd,string);
    System(cmd);
}

proc fillarray() {
    echo("",1);
    echo("------            Fill an array           ------",1);
    echo("Size of the array : ",0);
    int size;
    input(size,int);
    echo("Type of the elements (int, float, string, char) : ",0);
    string type;
    input(type,string);
    if (type == "int") {
        array(int)[size] values;
        int elem;
        for (int i = 0; i < size; i=i+1) {
            echo("Elem " & i & " : ",0);
            input(elem,int);
            values[i] = elem;
        }

        // displays the array
        echo("",1);
        echo("",1);
        for (int i = 0; i < size; i=i+1) {
            echo("Elem " & i & " = " & values[i],1);
        }
    }
    elseif (type == "float") {
        array(float)[size] values;
        float elem;
        for (int i = 0; i < size; i=i+1) {
            echo("Elem " & i & " : ",0);
            input(elem,float);
            values[i] = elem;
        }

        // displays the array
        echo("",1);
        echo("",1);
        for (int i = 0; i < size; i=i+1) {
            echo("Elem " & i & " = " & values[i],1);
        }
    }
    elseif (type == "string") {
        array(string)[size] values;
        string elem;
        for (int i = 0; i < size; i=i+1) {
            echo("Elem " & i & " : ",0);
            input(elem,string);
            values[i] = elem;
        }

        // displays the array
        echo("",1);
        echo("",1);
        for (int i = 0; i < size; i=i+1) {
            echo("Elem " & i & " = " & values[i],1);
        }
    }
    elseif (type == "char") {
        array(char)[size] values;
        char elem;
        for (int i = 0; i < size; i=i+1) {
            echo("Elem " & i & " : ",0);
            input(elem,char);
            values[i] = elem;
        }

        // displays the array
        echo("",1);
        echo("",1);
        for (int i = 0; i < size; i=i+1) {
            echo("Elem " & i & " = " & values[i],1);
        }
    }
    else {
        echo("Unrecognized type",1);
    }
}

entry {
    int ok = 1;
    int choice;
    while (ok) {
        menu();
        echo("> ",0);
        input(choice,int);
        echo("",1);

        switch (choice) {
            case (0) {
                ok = 0;
            }
            case (1) {
                fillarray();
            }
            case (2) {
                LaunchScript();
            }
            case (3) {
                SendCommand();
            }
            case (4) {
                fileManip();
            }
            default {
                echo("Invalid choice",1);
            }
        }
    }
}
